VERSION 5.00
Begin VB.Form frmCalculator 
   BorderStyle     =   1  'Fixed Single
   Caption         =   ""
   ClientHeight    =   2415
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   2535
   Icon            =   "frmCalculator.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2415
   ScaleWidth      =   2535
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSign 
      Caption         =   "+/-"
      Height          =   375
      Left            =   1080
      TabIndex        =   17
      Top             =   1920
      Width           =   375
   End
   Begin VB.CommandButton cmdDot 
      Caption         =   "."
      Height          =   375
      Left            =   600
      TabIndex        =   16
      Top             =   1920
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "0"
      Height          =   375
      Index           =   0
      Left            =   120
      TabIndex        =   15
      Top             =   1920
      Width           =   375
   End
   Begin VB.CommandButton cmdResult 
      Caption         =   "="
      Height          =   375
      Left            =   1560
      TabIndex        =   14
      Top             =   1920
      Width           =   855
   End
   Begin VB.CommandButton cmdFunction 
      Caption         =   "-"
      Height          =   375
      Index           =   2
      Left            =   2040
      TabIndex        =   13
      Top             =   1440
      Width           =   375
   End
   Begin VB.CommandButton cmdFunction 
      Caption         =   "+"
      Height          =   375
      Index           =   1
      Left            =   1560
      TabIndex        =   12
      Top             =   1440
      Width           =   375
   End
   Begin VB.CommandButton cmdFunction 
      Caption         =   "/"
      Height          =   375
      Index           =   4
      Left            =   2040
      TabIndex        =   11
      Top             =   960
      Width           =   375
   End
   Begin VB.CommandButton cmdFunction 
      Caption         =   "*"
      Height          =   375
      Index           =   3
      Left            =   1560
      TabIndex        =   10
      Top             =   960
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "3"
      Height          =   375
      Index           =   3
      Left            =   1080
      TabIndex        =   9
      Top             =   1440
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "2"
      Height          =   375
      Index           =   2
      Left            =   600
      TabIndex        =   8
      Top             =   1440
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "1"
      Height          =   375
      Index           =   1
      Left            =   120
      TabIndex        =   7
      Top             =   1440
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "6"
      Height          =   375
      Index           =   6
      Left            =   1080
      TabIndex        =   6
      Top             =   960
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "5"
      Height          =   375
      Index           =   5
      Left            =   600
      TabIndex        =   5
      Top             =   960
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "4"
      Height          =   375
      Index           =   4
      Left            =   120
      TabIndex        =   4
      Top             =   960
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "9"
      Height          =   375
      Index           =   9
      Left            =   1080
      TabIndex        =   3
      Top             =   480
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "8"
      Height          =   375
      Index           =   8
      Left            =   600
      TabIndex        =   2
      Top             =   480
      Width           =   375
   End
   Begin VB.CommandButton cmdDigit 
      Caption         =   "7"
      Height          =   375
      Index           =   7
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   375
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "C"
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      Top             =   480
      Width           =   855
   End
   Begin VB.Label lblDisplay 
      Alignment       =   1  'Right Justify
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   18
      Top             =   120
      Width           =   2295
   End
End
Attribute VB_Name = "frmCalculator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Private Const digitsCount As Byte = 10

Private x As Double, y As Double, action As Byte, newNumberWaiting As Boolean
Private sign As Boolean, integerEntry As Boolean
Private digitsInteger(0 To digitsCount - 1) As Byte
Private digitsFractional(1 To digitsCount - 1) As Byte
Private integerLength As Byte, fractionalLength As Byte

Private Sub clear()
  Dim i As Long
  sign = 0
  For i = 0 To digitsCount - 1
    digitsInteger(i) = 0
  Next i
  For i = 1 To digitsCount - 1
    digitsFractional(i) = 0
  Next i
  integerLength = 0
  fractionalLength = 0
  integerEntry = True
  calculateToRegister x
End Sub

Private Sub calculateToRegister(register As Double)
  Dim i As Long
  register = 0#
  For i = 1 To fractionalLength
    register = register + digitsFractional(i) * 10 ^ (-i)
  Next i
  For i = 0 To integerLength - 1
    register = register + digitsInteger(i) * 10 ^ (i)
  Next i
  If sign Then
    register = -register
  End If
End Sub

Private Sub digitEntry(ByVal digit As Byte, continueFractional As Boolean)
  Dim i As Long
  If newNumberWaiting Then
    clear
    newNumberWaiting = False
  End If
  If continueFractional Then
    integerEntry = False
  Else
    If integerEntry Then
      If integerLength <= digitsCount Then
        For i = integerLength To 1 Step -1
          digitsInteger(i) = digitsInteger(i - 1)
        Next i
        digitsInteger(0) = digit
        integerLength = integerLength + 1
      End If
    Else
      If integerLength + fractionalLength <= digitsCount Then
        digitsFractional(fractionalLength + 1) = digit
        fractionalLength = fractionalLength + 1
      End If
    End If
    calculateToRegister x
    updateDisplay
  End If
End Sub

Private Sub calculateResult()
  Select Case action
  Case 1
    x = y + x
  Case 2
    x = y - x
  Case 3
    x = y * x
  Case 4
    x = y / x
  End Select
  updateDisplay
End Sub

Private Sub updateDisplay()
  lblDisplay.Caption = CStr(x)
End Sub

Private Sub Form_Load()
  clear
  newNumberWaiting = False
  updateDisplay
End Sub

Private Sub cmdDigit_Click(Index As Integer)
  digitEntry Index, False
End Sub

Private Sub cmdDot_Click()
  digitEntry 0, True
End Sub

Private Sub cmdSign_Click()
  x = -x
  updateDisplay
End Sub

Private Sub cmdReset_Click()
  clear
  action = 0
  updateDisplay
End Sub

Private Sub cmdFunction_Click(Index As Integer)
  If action <> 0 Then
    calculateResult
  End If
  action = Index
  y = x
  newNumberWaiting = True
End Sub

Private Sub cmdResult_Click()
  calculateResult
  action = 0
  newNumberWaiting = True
End Sub
